20. 有效的括号
思路
算法原理
栈先入后出特点恰好与本题括号排序特点一致,即若遇到左括号入栈,遇到右括号时将对应栈顶左括号出栈,则遍历完所有括号后 stack 仍然为空;
建立哈希表 dic 构建左右括号对应关系:keykey 左括号,valuevalue 右括号;这样查询 22 个括号是否对应只需 O(1)O(1) 时间复杂度;建立栈 stack,遍历字符串 s 并按照算法流程一一判断。
算法流程
如果 c 是左括号,则入栈 push;
否则通过哈希表判断括号对应关系,若 stack 栈顶出栈括号 stack.pop() 与当前遍历括号 c 不对应,则提前返回 false。
提前返回 false
提前返回优点:
在迭代过程中,提前发现不符合的括号并且返回,提升算法效率。
解决边界问题:
栈 stack 为空: 此时 stack.pop() 操作会报错;因此,我们采用一个取巧方法,给 stack 赋初值 ?? ,并在哈希表 dic 中建立 key: ‘?’,value:’?’的对应关系予以配合。此时当 stack 为空且 c 为右括号时,可以正常提前返回 false;字符串 s 以左括号结尾: 此情况下可以正常遍历完整个 s,但 stack 中遗留未出栈的左括号;因此,最后需返回 len(stack) == 1,以判断是否是有效的括号组合。
代码
class Solution:
def isValid(self, s: str) -> bool:
dic = {'{': '}', '[': ']', '(': ')', '?': '?'}
stack = ['?']
for c in s:
if c in dic: stack.append(c)
elif dic[stack.pop()] != c: return False
return len(stack) == 1
class Solution {
private static final Map<Character,Character> map = new HashMap<Character,Character>(){{
put('{','}'); put('[',']'); put('(',')'); put('?','?');
}};
public boolean isValid(String s) {
if(s.length() > 0 && !map.containsKey(s.charAt(0))) return false;
LinkedList<Character> stack = new LinkedList<Character>() {{ add('?'); }};
for(Character c : s.toCharArray()){
if(map.containsKey(c)) stack.addLast(c);
else if(map.get(stack.removeLast()) != c) return false;
}
return stack.size() == 1;
}
}
496. 下一个更大元素 I
思路
采用先行将 nums2nums2 中的数字,对应的下一个更大的数字已经找出来,然后放到哈希表中,以供后面 nums1nums1 直接使用即可,可以将时间复杂度降到 n + mn+m。
具体流程
1.创建一个临时栈,一个哈希表,然后遍历 nums2nums2。
2.若当前栈无数据,则当前数字入栈备用。
3.若当前栈有数据,则用当前数字与栈顶比较:3.1 当前数字 > 栈顶,代表栈顶对应下一个更大的数字就是当前数字,则将该组数字对应关系,记录到哈希表。3.2 当前数字 < 栈顶,当前数字压入栈,供后续数字判断使用。
4可以看到哈希表中存在部分 nums2nums2 数字的对应关系了,而栈中留下的数字,代表无下一个更大的数字,我们全部赋值为 -1−1 ,然后存入哈希表。
5.遍历 nums1nums1,直接询问哈希表拿对应关系。
代码
class Solution:
def nextGreaterElement(self, nums1: List[int], nums2: List[int]) -> List[int]:
stack = []
res_dict = {i:-1 for i in nums2}
for i in nums2:
while stack and i > stack[-1]:
small = stack.pop()
res_dict[small] = i
stack.append(i)
res = []
for j in nums1:
res.append(res_dict[j])
return res
public class Solution {
public int[] nextGreaterElement(int[] nums1, int[] nums2) {
int len1 = nums1.length;
int len2 = nums2.length;
Deque<Integer> stack = new ArrayDeque<>();
Map<Integer, Integer> map = new HashMap<>();
for (int i = 0; i < len2; i++) {
while (!stack.isEmpty() && stack.peekLast() < nums2[i]) {
map.put(stack.removeLast(), nums2[i]);
}
stack.addLast(nums2[i]);
}
int[] res = new int[len1];
for (int i = 0; i < len1; i++) {
res[i] = map.getOrDefault(nums1[i], -1);
}
return res;
}
}